<?php

namespace Drupal\cryptolog;

use Drupal\Core\Config\BootstrapConfigStorageFactory;
use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceProviderBase;
use Symfony\Component\DependencyInjection\Reference;

/**
 * Injects the APCu cache so single-webhead sites can avoid database storage.
 */
class CryptologServiceProvider extends ServiceProviderBase {

  /**
   * {@inheritdoc}
   */
  public function alter(ContainerBuilder $container): void {
    global $config;
    $mergedConfig = $config['cryptolog.settings'] ?? [];
    $mergedConfig += BootstrapConfigStorageFactory::get()->read('cryptolog.settings') ?: [];
    if (!empty($mergedConfig['single_webhead']) && $container->hasDefinition('cryptolog.middleware')) {
      $container->getDefinition('cryptolog.middleware')->addArgument(new Reference('cache.backend.apcu'));
    }
  }

}
